/**
*	bios.c
*	oCIXx[`
*	Copyright 2008 Junnichi Tomaru
*/
#include	"mailchecker.h"

/* ---------- UART ---------- */

/* UART1M荞 */
#pragma interrupt uart1_int
void	uart1_int( void )
{
	ui_t	rxsts;

	rxsts.data = U1RB;
	if(( rxsts.bytes.hi & 0xf0 ) == 0 ){
		if( rx1ct < 255 ){
			rx1buf[rx1hp] = rxsts.bytes.lo;
			rx1hp++;
			rx1ct++;
		}
	}
}


/**
*	UART1M擾
*	 in	Ȃ
*	out	M
*/
byte	getsiocount( void )
{
	byte	ret;

	_di( );
	ret = rx1ct;
	_ei( );

	return	ret;
}


/**
*	UART1M
*	 in	Ȃ
*	out	M
*/
byte	getsio1( void )
{
	byte	ret;

	ret = 0xff;
	_di( );
	if( rx1ct > 0 ){
		ret = rx1buf[rx1tp];
		rx1tp++;
		rx1ct--;
	}
	_ei( );

	return	ret;
}


/**
*	UART1
*	 in	M
*	out	Ȃ
*/
void	setsio1( char data )
{
	while( TI_U1C1 == 0 )	/* M҂ */
	;
	U1TB = data;
}


/**
*	M҂
*	 in	Ȃ
*	out	1:OK 0:NG
*/
char	waitreceive( void )
{
	word	wt;
	char	ret;

	ret = 0;
	wt = getcount1ms( );
	while(( getcount1ms( ) - wt ) < 10000U ){/* ^CAEg10b */
		if( getsiocount( ) ){	/* M */
			ret = 1;
			break;
		}
	}

	return	ret;
}


/**
*	UART1MNA
*	 in	Ȃ
*	out	Ȃ
*/
void	clrsio( void )
{
	while( 1 ){
		if( getsio1( ) == 0xff ){
			break;
		}
		waitms( 1 );
	}
}


/**
*	UART1M
*	 in	buf: i[obt@
*		cnt: őM
*		 dl: f~^
*	out	0:f~^܂œǂ 1:őM܂œǂ 2:^CAEg
*/
char	getsiostr( char *buf, byte cnt, char dl )
{
	bool	ret;
	byte	i, c;
	word	wt;

	cnt--;	/* '\0'm */
	wt = getcount1ms( );
	for( i = 0; ; ){
		if( getsiocount( )){	/* M */
			c = getsio1( );
			if( c == dl ){	/* f~^ */
				*buf = '\0';
				ret = 0;
				break;
			}
			else if(( c != 0xff ) && ( c != '\n' )){
				/* f~^̂ƂŕI[̂LF͖ */
				*buf = c;
				buf++;
				i++;
			}
			if( i == cnt ){	/* JEg܂œǂ */
				*buf = '\0';
				ret = 1;
				break;
			}
		}
		if(( getcount1ms( ) - wt ) >= 3000U ){	/* ^CAEg */
			*buf = '\0';
			ret = 2;
			break;
		}
	}

	return	ret;
}


/**
*	UART1񑗐M
*	 in	M
*	out	Ȃ
*/
void	setsiostr( char *buf )
{
	while( *buf ){
		setsio1( *buf );
		buf++;
	}
	while( TXEPT_U1C0 == 1 ) /* U1TB->WX^҂ */
	;
	while( TXEPT_U1C0 == 0 ) /* M҂ */
	;
}


/* ---------- ^C}֘A ---------- */

/* ^C}RB荞(1ms) */
#pragma interrupt timer_rb
void	timer_rb( void )
{
	counter++;
	if(( counter & 0xf ) == 0 ){	/* 16ms */
		keybuf[keypnt] = (~PORT3) & 0x18;
		keypnt++;
		keypnt &= 0x3;
	}
	if(( counter % 1000 ) == 0 ){
		second++;
		if( second == 60 ){
			second = 0;
			minute++;
		}
	}
}


/**
*	1msPʂ̃JE^l
*	 in:Ȃ
*	out:JE^l
*/
word	getcount1ms( void )
{
	word	ret;

	_di( );
	ret = counter;
	_ei( );

	return	ret;
}


/**
*	1msPʑ҂
*	 in:҂ms
*	out:Ȃ
*/
void	waitms( word ms )
{
	word	wt;

	for( wt = getcount1ms( ); ( getcount1ms( ) - wt ) < ms; )
	;
}


/**
*	1minPʂ̃JE^l
*	 in:Ȃ
*	out:JE^l
*/
word	getminute( void )
{
	word	ret;

	_di( );
	ret = minute;
	_ei( );

	return	ret;
}


/* ---------- key֌W ---------- */
/**
*	XLR[hL[R[hϊ
*/
char	scantokey( byte scan )
{
	char	ret;

	if( scan == 0x08 ){
		ret = RIGHT_KEY;
	}
	else if( scan == 0x10 ){
		ret = LEFT_KEY;
	}
	else if( scan == 0x18 ){
		ret = CLEAR_KEY;
	}
	else{
		ret = NO_KEY;
	}

	return	ret;
}


/**
*	L[ZX
*/
char	keysense( void )
{
	char	keyc;
	byte	scan;
	static char	okey;

	_di( );
	scan = keybuf[0];	/* S񕪂̓͂ */
	scan &= keybuf[1];
	scan &= keybuf[2];
	scan &= keybuf[3];
	_ei( );
	if( scan != 0 ){	/* L[͂ */
		keyc = scantokey( scan );	/* R[hϊ */
		if( keyc == okey ){		/* OƓ */
			keyc = 0;	/* ͂ȂƂɂ */
		}
		else{
			okey = keyc;
		}
	}
	else{			/* ͂Ȃ */
		keyc = 0;
		okey = 0;
	}

	return	keyc;
}


/**
*	L[(҂)
*/
char	keyinput( void )
{
	char	keyc;
	word	wt;

	keyc = NO_KEY;
	wt = getcount1ms( );
	while(( getcount1ms( ) - wt ) < 10000U ){/* ^CAEg10b */
		keyc = keysense( );	/* L[ZX */
		if( keyc != 0 ){
			break;
		}
	}

	return	keyc;
}


/* ---------- EEPROM֘A ---------- */
#define	A_START		(( unsigned char * )0x2400)
#define	A_END		(( unsigned char * )0x27ff)
#define	B_START		(( unsigned char * )0x2800)
#define	B_END		(( unsigned char * )0x2bff)


/**
*	EEPROMubN
*	 in	AhX
*	out	TRUE:I  FALSE:G[
*/
bool	erase_eeprom( int addr )
{
	unsigned char	*adr, *adr2;
	bool	ret;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	adr = A_START + addr;
	adr2 = A_END + addr;
	*adr = 0x20;
	*adr2 = 0xd0;
	while( FMR00 == 0 );	/* I҂ */
	ret = ( FMR07 == 1 )? TRUE: FALSE;
	FMR01 = 0;	/* ݋֎~ */
	_ei( );

	return	ret;
}


/**
*	EEPROMXe[^Xǂݍ
*	 IN	eadr: ݏ܂ĂAhX(ݎ)
*		wadr: ݐAhX
*	OUT	1:Ă
*/
char	get_settei( int *eadr, int *wadr )
{
	char	c, d, ret;

	read_eeprom( A_TOP, &c, 1 );	/* tO */
	read_eeprom( B_TOP, &d, 1 );
	ret = 0;
	if( c == 0x1 ){		/* A͏Ă */
		*eadr = 0;
		*wadr = 1024;
	}
	else if( d == 0x1 ){	/* B͏Ă */
		*eadr = 1024;
		*wadr = 0;
	}
	else{			/* Ă */
		*eadr = *wadr = 0;
		ret = 1;
	}

	return	ret;
}


/**
*	EEPROMǂݏo
*	 in	addr	AhX(0000`2047)
*			(A:0000`1023, B:1024`2047)
*		data	i[
*		cnt	
*	out	Ȃ
*/
void	read_eeprom( int addr, char *data, int cnt )
{
	unsigned char	*adr;
	int	i;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	adr = A_START + addr;
	*adr = 0xff;	/* ǂݏoR}h */
	for( i = 0; i < cnt; i++, data++, adr++ ){
		*data = *adr;
	}
	_ei( );
	FMR01 = 0;	/* ANZX֎~ */
}


/**
*	EEPROM
*	 in	addr	AhX(0000`2047)
*			(A:0000`1023, B:1024`2047)
*		data	f[^
*		cnt	
*	out	TRUE:  FALSE:G[
*/
bool	write_eeprom( int addr, char *data, int cnt )
{
	unsigned char	*adr;
	int	i;
	bool	ret;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	*adr = 0x50;	/* Xe[^XNA */
	adr = A_START + addr;
	for( i = 0; i < cnt; i++, data++, adr++ ){
		*adr = 0x40;	/* ݃R}h */
		*adr = *data;
		while( FMR00 == 0 );/* ҂ */
		ret = !FMR06;	/* G[`FbN */
	}
	FMR01 = 0;	/* ANZX֎~ */
	_ei( );

	return	ret;
}


/* end of bios.c */
